Subject: [lisp] architecturally separate name-spaces - but assumption about a single value means same thing if in both?

From: Alia Atlas <[email-masked]>
Date: Wed, 22 Jun 2011 18:38:21 -0400

>From the discussion on draft comments, I have the following basic question:

Is a value A is assigned to either the EID space or the RLOC space?
Could site X have an EID with value A while site Y (or
even a non-LISP) has an RLOC (or globally routable address) with the
same value A?

For instance, consider deploying an IPv4 LISP site now.  Could one
take an IPv4 prefix already used
globally by a different company/site - and use it for my new LISP site
as an EID prefix?

Do all the drafts always check for the IP address in the mapping
database to see if it is an EID?  I recall seeing some
cases of checking the global routing table - but that could be bad
memory at this point.

Could a host in a LISP site send to an IP address as an EID and the
same IP address as a globally addressable (or routable)?

I am confused because "architecturally" I believe the EID space and
the RLOC space are separate namespaces - but in practice
in the drafts, it seems that a given value must belong to a single
entity, whether it is used as an EID, globally addressable, or both.

Is this clearly specified anywhere?  What am I missing?

Alia

---

From: Dino Farinacci <[email-masked]>
Date: Wed, 22 Jun 2011 16:02:48 -0700

> even a non-LISP) has an RLOC (or globally routable address) with the

Architecturally, yes, the value A can be an EID and an RLOC. In  
practice, no, for IPv4 and maybe for IPv6. Let me explain.

Since there are two namespaces for each of IPv4 and IPv6, it means,  
for the case of IPv4, there are two 2^^32 number assignment spaces.  
But we don't have two allocation authorities, one for each, so the  
addresses will be assigned from one 2^^32 pool and be used as either  
an EID or an RLOC depending if the site has converted to being a LISP  
site.

For IPv6, if we had a PI allocation authority, then it would hand out  
EID prefixes to end sites. If we also had a PA allocation authority,  
then it would hand out RLOC addresses to infrastructure providers. In  
this case, if the two authorities acted independently, then the same  
value could be assigned for each namespace.

This is not a problem to duplicate the address in each namespace. But  
I do believe for operational sanity it would be nice to look at logs,  
debugs, or whatever, see an address and decipher it is an EID versus  
an RLOC. This is one of the reasons the working group wants to request  
an IANA assigned /12 or /16 (not decided yet I think).

> globally by a different company/site - and use it for my new LISP site

No because there is one allocation authority and it is enforcing a  
unique address allocation policy.

> cases of checking the global routing table - but that could be bad

If you look in the ALT routing table and find a prefix, it is an EID.  
That is an example of looking in *a routing table*. But that is part  
of the mapping database system. So it is one in the same.

> same IP address as a globally addressable (or routable)?

A host sends to destinations. So it doesn't know one from the other (a  
feature). So yes, both a non-LISP site host and a LISP site host can  
talk to both a non-LISP site and LISP site destination.

> entity, whether it is used as an EID, globally addressable, or both.

That is what you get when you build an architecture after the network  
is built.  ;-)

Dino

> _______________________________________________
> lisp mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/lisp

---

From: Alia Atlas <[email-masked]>
Date: Thu, 23 Jun 2011 14:43:21 -0400

So - although theoretically the value A can be an EID and an RLOC, the LISP
protocol as specified does not permit this.

I understand that was a choice started based upon assumptions around the
allocation authority for number spaces.

I strongly think that this clarification must be made in the [LISP]
draft.  Without
that assumption, various parts of what is specified simply do not work.

Alia

On Wed, Jun 22, 2011 at 7:02 PM, Dino Farinacci <[email-masked]> wrote:
> Architecturally, yes, the value A can be an EID and an RLOC. In practice,
> no, for IPv4 and maybe for IPv6. Let me explain.
>
> Since there are two namespaces for each of IPv4 and IPv6, it means, for the
> case of IPv4, there are two 2^^32 number assignment spaces. But we don't
> have two allocation authorities, one for each, so the addresses will be
> assigned from one 2^^32 pool and be used as either an EID or an RLOC
> depending if the site has converted to being a LISP site.
>
> For IPv6, if we had a PI allocation authority, then it would hand out EID
> prefixes to end sites. If we also had a PA allocation authority, then it
> would hand out RLOC addresses to infrastructure providers. In this case, if
> the two authorities acted independently, then the same value could be
> assigned for each namespace.
>
> This is not a problem to duplicate the address in each namespace. But I do
> believe for operational sanity it would be nice to look at logs, debugs, or
> whatever, see an address and decipher it is an EID versus an RLOC. This is
> one of the reasons the working group wants to request an IANA assigned /12
> or /16 (not decided yet I think).
>
> No because there is one allocation authority and it is enforcing a unique
> address allocation policy.
>
> If you look in the ALT routing table and find a prefix, it is an EID. That
> is an example of looking in *a routing table*. But that is part of the
> mapping database system. So it is one in the same.
>
> feature). So yes, both a non-LISP site host and a LISP site host can talk to
> both a non-LISP site and LISP site destination.
>
> That is what you get when you build an architecture after the network is
> built.  ;-)
>
> Dino
>

---

From: Alia Atlas <[email-masked]>
Date: Thu, 23 Jun 2011 14:52:28 -0400

Sorry - a couple more comments in-line:

> or /16 (not decided yet I think).

I believe there are assumptions in the drafts now that prevent duplicating an
address in each namespace.

> address allocation policy.

If you decided that EIDs were a real separate namespace - managed by another
entity?

> mapping database system. So it is one in the same.

I believe it was, and certainly my interpretation, was to look it up
in the "Global
Routing Table".   For consistency, if a lookup is done in the Routing Database,
then the same terminology should be used.

> both a non-LISP site and LISP site destination.

Let me provide examples, since I strongly think the answer is NO and feel you
have side-stepped the question into vague generalities that ignores the issue.

An end-host in a LISP site puts a destination of A in its packet.  The
ITR checks
for A in the Mapping Database & finds it.  Therefore, the ITR
encapsulates the packet
and sends it to an RLOC specified in the locator-set.  There is NO WAY
for a LISP end-host
to send a packet to the globally addressable destination A - unless
the EID A and the
globally addressable destination A refer to the exact same host.

Similarly, an end-host that is not in a LISP site puts a destination
of A in its packet.
If an PITR tries to claim value A because it is an EID, then depending
on route-preferences,
the non-LISP end-host may be able to send to globally addressable
destination A or its
traffic might end up going to the advertising PITR.

> That is what you get when you build an architecture after the network is

It is an amusing challenge - but basic architectural assumptions need
to be clearly
documented as the reality they are.

Alia

---

From: "Joel M. Halpern" <[email-masked]>
Date: Thu, 23 Jun 2011 15:37:59 -0400

I don't think your paraphrase quite captures it.
In the abstract theory, the bit string represented by A could be an EID 
for one device and an RLOC for a different device.
As the architecture is realized, if a given bit string is both an RLOC 
and an EID, it must refer to the same entity in both cases.

Yours,
Joel

On 6/23/2011 2:43 PM, Alia Atlas wrote:
> On Wed, Jun 22, 2011 at 7:02 PM, Dino Farinacci<[email-masked]>  wrote:

---

From: Dino Farinacci <[email-masked]>
Date: Thu, 23 Jun 2011 13:23:50 -0700

> have side-stepped the question into vague generalities that ignores  

I will be very specific. Today my systems at home use an EID for TCP  
connections. That same 32-bit value is used as an RLOC for LISP  
encapsulating packets that come into my house.

Dino

---

From: Alia Atlas <[email-masked]>
Date: Thu, 23 Jun 2011 16:25:04 -0400

Yes - so the EID and RLOC refer to the same end-host.

---

From: Alia Atlas <[email-masked]>
Date: Thu, 23 Jun 2011 16:25:35 -0400

Joel,

Yes, thank you - that is a better phrasing.

Alia

On Thu, Jun 23, 2011 at 3:37 PM, Joel M. Halpern <[email-masked]> wrote:
> In the abstract theory, the bit string represented by A could be an EID for
> one device and an RLOC for a different device.
> As the architecture is realized, if a given bit string is both an RLOC and
> an EID, it must refer to the same entity in both cases.
>
> Yours,
> Joel
>
>>> That

---

From: Dino Farinacci <[email-masked]>
Date: Thu, 23 Jun 2011 13:25:44 -0700

> Yes - so the EID and RLOC refer to the same end-host.

Wrong. The EID is assigned to the end-host and the RLOC is assigned to  
the LISP router.

Dino

>>>> feature). So yes, both a non-LISP site host and a LISP site host  
>>>> can talk
>>>> to
>>> Let me provide examples, since I strongly think the answer is NO  
>>> and feel
>>> you
>>> have side-stepped the question into vague generalities that  
>>> ignores the
>>> issue.
>>

---

From: Alia Atlas <[email-masked]>
Date: Thu, 23 Jun 2011 16:33:08 -0400

On Thu, Jun 23, 2011 at 4:25 PM, Dino Farinacci <[email-masked]> wrote:
> Wrong. The EID is assigned to the end-host and the RLOC is assigned to the
> LISP router.

Fine - but if the RLOC were a globally routable address assigned to me
instead of
your LISP router- then your computer with its EID couldn't talk to me.
 (and you might
be happier ;-)

(And an end-host can have a globally routable address during
transition for interworking..)

Alia

P.S.  Do you disagree with Joel's rephrasing of the issue?

>>>>> talk
>>>> Let me provide examples, since I strongly think the answer is NO and
>>>> feel
>>>> you

---

From: Dino Farinacci <[email-masked]>
Date: Thu, 23 Jun 2011 13:34:29 -0700

> your LISP router- then your computer with its EID couldn't talk to me.

It would still work. You are missing something conceptually. We have  
to talk through this. Maybe at IETF if you are going to be there.

Dino

>>>>> and

---

From: Alia Atlas <[email-masked]>
Date: Thu, 23 Jun 2011 16:38:20 -0400

I'd be quite happy to chat at IETF.   Could you look at the details of
the cases I sent and tell
me what I'm missing?

Do you disagree with Joel's rephrasing of my concern?

Alia

On Thu, Jun 23, 2011 at 4:34 PM, Dino Farinacci <[email-masked]> wrote:
>>> the
> It would still work. You are missing something conceptually. We have to talk
> through this. Maybe at IETF if you are going to be there.
>
> Dino
>
>>
>>>>>> have side-stepped the question into vague generalities that ignores
>>>>>> the
>>>>>> issue.
>>>>>